# Cobalt Strike流量解密

🏃来不及解释了，CS，启动！🎯
&lt;!--more--&gt;

这里以一道CTF题目来讲，题目中肯定会提供`.cobaltstrike.beacon_keys`文件，实际上这个文件本质上为KeyPair的Java对象，Python的javaobj-py3库是可以直接读取其中存储的数据。
首先，使用`parse_beacon_keys.py`来分析.cobaltstrike.beacon_keys文件
```python
import base64

import javaobj.v2 as javaobj

with open(&#34;.cobaltstrike.beacon_keys&#34;, &#34;rb&#34;) as fd:
    pobj = javaobj.load(fd)
privateKey = pobj.array.value.privateKey.encoded.data
publicKey = pobj.array.value.publicKey.encoded.data


privateKey = (
    b&#34;-----BEGIN PRIVATE KEY-----\n&#34;
    &#43; base64.encodebytes(bytes(map(lambda x: x &amp; 0xFF, privateKey)))
    &#43; b&#34;-----END PRIVATE KEY-----&#34;
)
publicKey = (
    b&#34;-----BEGIN PUBLIC KEY-----\n&#34;
    &#43; base64.encodebytes(bytes(map(lambda x: x &amp; 0xFF, publicKey)))
    &#43; b&#34;-----END PUBLIC KEY-----&#34;
)
print(privateKey.decode())
print(publicKey.decode())

# print(
#     list(
#         map(
#             lambda x: list(map(lambda y: (y[0].name, y[1]), x.items())),
#             a.field_data.values(),
#         )
#     )
# )
```
可以得到公私钥
```
-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBAMDK2njlzNZQTuxA&#43;EkOfL8ewGf9
QBolYb8S&#43;oWvthlDi4powMkXT4piN2nMHh&#43;YLJzMoq0Rr9ufalC/mHwIhGBEc62tltd6lnZEWDmj
syRtY&#43;lLhoTVU9GYsUY0bI5z6Sco0MW4OTz760ZyHQLl&#43;iLAPm3C2X7FFt9aSl&#43;i6prdAgMBAAEC
gYADgF9bBvzPhBmlT/ev&#43;JqUZ2p1tpNZRjeINyJfIKnNRZXRF5mSSvANOz8KUfqHxazgNik9H13/
Uhj&#43;j5kvG4HgjrdNkYtfpg6pfoY7G0g3BR/kTjwAaIb9jWYPGm40xNGXR1qHRR2fxEc3Wz&#43;OD01l
K&#43;tpWo3lifJ0j7bvQiIX4QJBAOhfvUxWI2FOfdQVdYjWl2AyUcpTL3HBWF0e7HzbZn&#43;L3CJs0Cwt
iZxs3r2EEbR7XfMcwmCPrcDv1ATXlKka4G0CQQDUZOEVlS/5Ly8it&#43;WrtpMRHf5RUBT1cxJZrNRS
Wy/Kj&#43;GoQLv9uoamUNiN5PBY4W3AV2NoEx39WIKfs1rhkH4xAkAS9XS5XLHIR6ImgpWzU2bIV3Kq
4jyVuGOgPVyoFzJ2p4&#43;PU3dsk06N76gAqFzVb9dLdYY6YJ6ZhjezKW&#43;cmG/FAkEAjsSkvFJFJhX&#43;
dDLzMkKOhwIHUncnL3pDSn4vVpCvBlVDFUs2Uq7QFfngJzlOCiC2GoVjb7DyBrs5SspP&#43;7GZ8QJB
AK&#43;t1cHHEi/71bm0HaVeYKck8Rtgrf&#43;vhbLCT0h/9Kechfo2HtzrW0YX&#43;wgknLyq53TwrqKtcxOl
qhcXUY&#43;7p1E=
-----END PRIVATE KEY-----

-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDAytp45czWUE7sQPhJDny/HsBn/UAaJWG/EvqF
r7YZQ4uKaMDJF0&#43;KYjdpzB4fmCyczKKtEa/bn2pQv5h8CIRgRHOtrZbXepZ2RFg5o7MkbWPpS4aE
1VPRmLFGNGyOc&#43;knKNDFuDk8&#43;&#43;tGch0C5foiwD5twtl&#43;xRbfWkpfouqa3QIDAQAB
-----END PUBLIC KEY-----
```
接下来使用`Beacon_metadata_RSA_Decrypt.py`从请求数据包中解密Cookie数据

![](/images/1710903164675.png)

```python
&#39;&#39;&#39;
Beacon元数据
&#39;&#39;&#39;
import hashlib
import M2Crypto
import base64
import hexdump

PRIVATE_KEY = &#34;&#34;&#34;
-----BEGIN PRIVATE KEY-----
MIICdwIBADANBgkqhkiG9w0BAQEFAASCAmEwggJdAgEAAoGBAMDK2njlzNZQTuxA&#43;EkOfL8ewGf9
QBolYb8S&#43;oWvthlDi4powMkXT4piN2nMHh&#43;YLJzMoq0Rr9ufalC/mHwIhGBEc62tltd6lnZEWDmj
syRtY&#43;lLhoTVU9GYsUY0bI5z6Sco0MW4OTz760ZyHQLl&#43;iLAPm3C2X7FFt9aSl&#43;i6prdAgMBAAEC
gYADgF9bBvzPhBmlT/ev&#43;JqUZ2p1tpNZRjeINyJfIKnNRZXRF5mSSvANOz8KUfqHxazgNik9H13/
Uhj&#43;j5kvG4HgjrdNkYtfpg6pfoY7G0g3BR/kTjwAaIb9jWYPGm40xNGXR1qHRR2fxEc3Wz&#43;OD01l
K&#43;tpWo3lifJ0j7bvQiIX4QJBAOhfvUxWI2FOfdQVdYjWl2AyUcpTL3HBWF0e7HzbZn&#43;L3CJs0Cwt
iZxs3r2EEbR7XfMcwmCPrcDv1ATXlKka4G0CQQDUZOEVlS/5Ly8it&#43;WrtpMRHf5RUBT1cxJZrNRS
Wy/Kj&#43;GoQLv9uoamUNiN5PBY4W3AV2NoEx39WIKfs1rhkH4xAkAS9XS5XLHIR6ImgpWzU2bIV3Kq
4jyVuGOgPVyoFzJ2p4&#43;PU3dsk06N76gAqFzVb9dLdYY6YJ6ZhjezKW&#43;cmG/FAkEAjsSkvFJFJhX&#43;
dDLzMkKOhwIHUncnL3pDSn4vVpCvBlVDFUs2Uq7QFfngJzlOCiC2GoVjb7DyBrs5SspP&#43;7GZ8QJB
AK&#43;t1cHHEi/71bm0HaVeYKck8Rtgrf&#43;vhbLCT0h/9Kechfo2HtzrW0YX&#43;wgknLyq53TwrqKtcxOl
qhcXUY&#43;7p1E=
-----END PRIVATE KEY-----
&#34;&#34;&#34;

encode_data = &#34;PcdKQuOPNdlyJMzB9IdLt3FyYJK5ooh2hagReIiCPX3enVE8IUWclknGedXTxAW6Seq0pUuqbA3d6h59a43lQH&#43;2l4egkNL/aTuaMndjIcrM7HFHDQSumu/VoeG&#43;O9vNB63W6YtJDidYt&#43;SjFCZPOjcTblEU&#43;CDGzN4xNO&#43;bh1s=&#34;
base64_key = &#34;&#34;

pubkey = M2Crypto.RSA.load_key_string(PRIVATE_KEY.format(base64_key).encode())
ciphertext = pubkey.private_decrypt(base64.b64decode(encode_data), M2Crypto.RSA.pkcs1_padding)



def isFlag(var, flag)
:
	return (var &amp; flag)
 == flag


def toIP(var):
	var2 = (var &amp; -16777216) &gt;&gt; 24
	var4 = (var &amp; 16711680) &gt;&gt; 16
	var6 = (var &amp; 65280) &gt;&gt; 8
	var8 = var &amp; 255
	return str(var2) &#43; &#34;.&#34; &#43; str(var4) &#43; &#34;.&#34; &#43; str(var6) &#43; &#34;.&#34; &#43; str(var8)


def getName(var0):
	if var0 == 37:
		return &#34;IBM037&#34;
	elif var0 == 437:
		return &#34;IBM437&#34;
	elif var0 == 500:
		return &#34;IBM500&#34;
	elif var0 == 708:
		return &#34;ISO-8859-6&#34;
	elif var0 == 709:
		return &#34;&#34;
	elif var0 == 710:
		return &#34;&#34;
	elif var0 == 720:
		return &#34;IBM437&#34;
	elif var0 == 737:
		return &#34;x-IBM737&#34;
	elif var0 == 775:
		return &#34;IBM775&#34;
	elif var0 == 850:
		return &#34;IBM850&#34;
	elif var0 == 852:
		return &#34;IBM852&#34;
	elif var0 == 855:
		return &#34;IBM855&#34;
	elif var0 == 857:
		return &#34;IBM857&#34;
	elif var0 == 858:
		return &#34;IBM00858&#34;
	elif var0 == 860:
		return &#34;IBM860&#34;
	elif var0 == 861:
		return &#34;IBM861&#34;
	elif var0 == 862:
		return &#34;IBM862&#34;
	elif var0 == 863:
		return &#34;IBM863&#34;
	elif var0 == 864:
		return &#34;IBM864&#34;
	elif var0 == 865:
		return &#34;IBM865&#34;
	elif var0 == 866:
		return &#34;IBM866&#34;
	elif var0 == 869:
		return &#34;IBM869&#34;
	elif var0 == 870:
		return &#34;IBM870&#34;
	elif var0 == 874:
		return &#34;x-windows-874&#34;
	elif var0 == 875:
		return &#34;IBM875&#34;
	elif var0 == 932:
		return &#34;Shift_JIS&#34;
	elif var0 == 936:
		return &#34;x-mswin-936&#34;
	elif var0 == 949:
		return &#34;x-windows-949&#34;
	elif var0 == 950:
		return &#34;Big5&#34;
	elif var0 == 1026:
		return &#34;IBM1026&#34;
	elif var0 == 1047:
		return &#34;IBM1047&#34;
	elif var0 == 1140:
		return &#34;IBM01140&#34;
	elif var0 == 1141:
		return &#34;IBM01141&#34;
	elif var0 == 1142:
		return &#34;IBM01142&#34;
	elif var0 == 1143:
		return &#34;IBM01143&#34;
	elif var0 == 1144:
		return &#34;IBM01144&#34;
	elif var0 == 1145:
		return &#34;IBM01145&#34;
	elif var0 == 1146:
		return &#34;IBM01146&#34;
	elif var0 == 1147:
		return &#34;IBM01147&#34;
	elif var0 == 1148:
		return &#34;IBM01148&#34;
	elif var0 == 1149:
		return &#34;IBM01149&#34;
	elif var0 == 1200:
		return &#34;UTF-16LE&#34;
	elif var0 == 1201:
		return &#34;UTF-16BE&#34;
	elif var0 == 1250:
		return &#34;windows-1250&#34;
	elif var0 == 1251:
		return &#34;windows-1251&#34;
	elif var0 == 1252:
		return &#34;windows-1252&#34;
	elif var0 == 1253:
		return &#34;windows-1253&#34;
	elif var0 == 1254:
		return &#34;windows-1254&#34;
	elif var0 == 1255:
		return &#34;windows-1255&#34;
	elif var0 == 1256:
		return &#34;windows-1256&#34;
	elif var0 == 1257:
		return &#34;windows-1257&#34;
	elif var0 == 1258:
		return &#34;windows-1258&#34;
	elif var0 == 1361:
		return &#34;x-Johab&#34;
	elif var0 == 10000:
		return &#34;x-MacRoman&#34;
	elif var0 == 10001:
		return &#34;&#34;
	elif var0 == 10002:
		return &#34;&#34;
	elif var0 == 10003:
		return &#34;&#34;
	elif var0 == 10004:
		return &#34;x-MacArabic&#34;
	elif var0 == 10005:
		return &#34;x-MacHebrew&#34;
	elif var0 == 10006:
		return &#34;x-MacGreek&#34;
	elif var0 == 10007:
		return &#34;x-MacCyrillic&#34;
	elif var0 == 10008:
		return &#34;&#34;
	elif var0 == 10010:
		return &#34;x-MacRomania&#34;
	elif var0 == 10017:
		return &#34;x-MacUkraine&#34;
	elif var0 == 10021:
		return &#34;x-MacThai&#34;
	elif var0 == 10029:
		return &#34;x-MacCentralEurope&#34;
	elif var0 == 10079:
		return &#34;x-MacIceland&#34;
	elif var0 == 10081:
		return &#34;x-MacTurkish&#34;
	elif var0 == 10082:
		return &#34;x-MacCroatian&#34;
	elif var0 == 12000:
		return &#34;UTF-32LE&#34;
	elif var0 == 12001:
		return &#34;UTF-32BE&#34;
	elif var0 == 20000:
		return &#34;x-ISO-2022-CN-CNS&#34;
	elif var0 == 20001:
		return &#34;&#34;
	elif var0 == 20002:
		return &#34;&#34;
	elif var0 == 20003:
		return &#34;&#34;
	elif var0 == 20004:
		return &#34;&#34;
	elif var0 == 20005:
		return &#34;&#34;
	elif var0 == 20105:
		return &#34;&#34;
	elif var0 == 20106:
		return &#34;&#34;
	elif var0 == 20107:
		return &#34;&#34;
	elif var0 == 20108:
		return &#34;&#34;
	elif var0 == 20127:
		return &#34;US-ASCII&#34;
	elif var0 == 20261:
		return &#34;&#34;
	elif var0 == 20269:
		return &#34;&#34;
	elif var0 == 20273:
		return &#34;IBM273&#34;
	elif var0 == 20277:
		return &#34;IBM277&#34;
	elif var0 == 20278:
		return &#34;IBM278&#34;
	elif var0 == 20280:
		return &#34;IBM280&#34;
	elif var0 == 20284:
		return &#34;IBM284&#34;
	elif var0 == 20285:
		return &#34;IBM285&#34;
	elif var0 == 20290:
		return &#34;IBM290&#34;
	elif var0 == 20297:
		return &#34;IBM297&#34;
	elif var0 == 20420:
		return &#34;IBM420&#34;
	elif var0 == 20423:
		return &#34;&#34;
	elif var0 == 20424:
		return &#34;IBM424&#34;
	elif var0 == 20833:
		return &#34;&#34;
	elif var0 == 20838:
		return &#34;IBM-Thai&#34;
	elif var0 == 20866:
		return &#34;KOI8-R&#34;
	elif var0 == 20871:
		return &#34;IBM871&#34;
	elif var0 == 20880:
		return &#34;&#34;
	elif var0 == 20905:
		return &#34;&#34;
	elif var0 == 20924:
		return &#34;&#34;
	elif var0 == 20932:
		return &#34;EUC-JP&#34;
	elif var0 == 20936:
		return &#34;GB2312&#34;
	elif var0 == 20949:
		return &#34;&#34;
	elif var0 == 21025:
		return &#34;x-IBM1025&#34;
	elif var0 == 21027:
		return &#34;&#34;
	elif var0 == 21866:
		return &#34;KOI8-U&#34;
	elif var0 == 28591:
		return &#34;ISO-8859-1&#34;
	elif var0 == 28592:
		return &#34;ISO-8859-2&#34;
	elif var0 == 28593:
		return &#34;ISO-8859-3&#34;
	elif var0 == 28594:
		return &#34;ISO-8859-4&#34;
	elif var0 == 28595:
		return &#34;ISO-8859-5&#34;
	elif var0 == 28596:
		return &#34;ISO-8859-6&#34;
	elif var0 == 28597:
		return &#34;ISO-8859-7&#34;
	elif var0 == 28598:
		return &#34;ISO-8859-8&#34;
	elif var0 == 28599:
		return &#34;ISO-8859-9&#34;
	elif var0 == 28603:
		return &#34;ISO-8859-13&#34;
	elif var0 == 28605:
		return &#34;ISO-8859-15&#34;
	elif var0 == 29001:
		return &#34;&#34;
	elif var0 == 38598:
		return &#34;ISO-8859-8&#34;
	elif var0 == 50220:
		return &#34;ISO-2022-JP&#34;
	elif var0 == 50221:
		return &#34;ISO-2022-JP-2&#34;
	elif var0 == 50222:
		return &#34;ISO-2022-JP&#34;
	elif var0 == 50225:
		return &#34;ISO-2022-KR&#34;
	elif var0 == 50227:
		return &#34;ISO-2022-CN&#34;
	elif var0 == 50229:
		return &#34;ISO-2022-CN&#34;
	elif var0 == 50930:
		return &#34;x-IBM930&#34;
	elif var0 == 50931:
		return &#34;&#34;
	elif var0 == 50933:
		return &#34;x-IBM933&#34;
	elif var0 == 50935:
		return &#34;x-IBM935&#34;
	elif var0 == 50936:
		return &#34;&#34;
	elif var0 == 50937:
		return &#34;x-IBM937&#34;
	elif var0 == 50939:
		return &#34;x-IBM939&#34;
	elif var0 == 51932:
		return &#34;EUC-JP&#34;
	elif var0 == 51936:
		return &#34;GB2312&#34;
	elif var0 == 51949:
		return &#34;EUC-KR&#34;
	elif var0 == 51950:
		return &#34;&#34;
	elif var0 == 52936:
		return &#34;GB2312&#34;
	elif var0 == 54936:
		return &#34;GB18030&#34;
	elif var0 == 57002:
		return &#34;x-ISCII91&#34;
	elif var0 == 57003:
		return &#34;x-ISCII91&#34;
	elif var0 == 57004:
		return &#34;x-ISCII91&#34;
	elif var0 == 57005:
		return &#34;x-ISCII91&#34;
	elif var0 == 57006:
		return &#34;x-ISCII91&#34;
	elif var0 == 57007:
		return &#34;x-ISCII91&#34;
	elif var0 == 57008:
		return &#34;x-ISCII91&#34;
	elif var0 == 57009:
		return &#34;x-ISCII91&#34;
	elif var0 == 57010:
		return &#34;x-ISCII91&#34;
	elif var0 == 57011:
		return &#34;x-ISCII91&#34;
	elif var0 == 65000:
		return &#34;&#34;
	elif var0 == 65001:
		return &#34;UTF-8&#34;


if ciphertext[0:4] == b&#39;\x00\x00\xBE\xEF&#39;:

	# 16
	raw_aes_keys = ciphertext[8:24]

	# 2
	var9 = ciphertext[24:26]
	var9 = int.from_bytes(var9, byteorder=&#39;little&#39;, signed=False)
	var9 = getName(var9)
	# 2
	var10 = ciphertext[26:28]
	var10 = int.from_bytes(var10, byteorder=&#39;little&#39;, signed=False)
	var10 = getName(var10)

	# 4
	id = ciphertext[28:32]
	id = int.from_bytes(id, byteorder=&#39;big&#39;, signed=False)
	print(&#34;Beacon id:{}&#34;.format(id))

	# 4
	pid = ciphertext[32:36]
	pid = int.from_bytes(pid, byteorder=&#39;big&#39;, signed=False)
	print(&#34;pid:{}&#34;.format(pid))

	# 2
	port = ciphertext[36:38]
	port = int.from_bytes(port, byteorder=&#39;big&#39;, signed=False)
	print(&#34;port:{}&#34;.format(port))

	# 1
	flag = ciphertext[38:39]
	flag = int.from_bytes(flag, byteorder=&#39;big&#39;, signed=False)
	# print(flag)


	if isFlag(flag, 1):
		barch = &#34;&#34;
		pid = &#34;&#34;
		is64 = &#34;&#34;
	elif isFlag(flag, 2):
		barch = &#34;x64&#34;
	else:
		barch = &#34;x86&#34;

	if isFlag(flag, 4):
		is64 = &#34;1&#34;
	else:
		is64 = &#34;0&#34;

	if isFlag(flag, 8):
		bypassuac = &#34;True&#34;
	else:
		bypassuac = &#34;False&#34;

	print(&#34;barch:&#34; &#43; barch)
	print(&#34;is64:&#34; &#43; is64)
	print(&#34;bypass:&#34; &#43; bypassuac)

	# 2
	var_1 = ciphertext[39:40]
	var_2 = ciphertext[40:41]
	var_1 = int.from_bytes(var_1, byteorder=&#39;big&#39;, signed=False)
	var_2 = int.from_bytes(var_2, byteorder=&#39;big&#39;, signed=False)
	windows_var = str(var_1) &#43; &#34;.&#34; &#43; str(var_2)
	print(&#34;windows var:&#34; &#43; windows_var)

	# 2
	windows_build = ciphertext[41:43]
	windows_build = int.from_bytes(windows_build, byteorder=&#39;big&#39;, signed=False)
	print(&#34;windows build:{}&#34;.format(windows_build))

	# 4
	x64_P = ciphertext[43:47]

	# 4
	ptr_gmh = ciphertext[47:51]
	# 4
	ptr_gpa = ciphertext[51:55]

	# if (&#34;x64&#34;.equals(this.barch)) {
	# this.ptr_gmh = CommonUtils.join(var10, this.ptr_gmh)
	# this.ptr_gpa = CommonUtils.join(var10, this.ptr_gpa)
	# }
	#
	# this.ptr_gmh = CommonUtils.bswap(this.ptr_gmh)
	# this.ptr_gpa = CommonUtils.bswap(this.ptr_gpa)

	# 4
	intz = ciphertext[55:59]
	intz = int.from_bytes(intz, byteorder=&#39;little&#39;, signed=False)
	intz = toIP(intz)

	if intz == &#34;0.0.0.0&#34;:
		intz = &#34;unknown&#34;
	print(&#34;host:&#34; &#43; intz)

	if var9 == None:
		ddata = ciphertext[59:len(ciphertext)].decode(&#34;ISO8859-1&#34;)
	else:
		# ??x-mswin-936
		# ddata = ciphertext[59:len(ciphertext)].decode(var9)
		ddata = ciphertext[59:len(ciphertext)].decode(&#34;ISO8859-1&#34;)

	ddata = ddata.split(&#34;\t&#34;)
	if len(ddata) &gt; 0:
		computer = ddata[0]
	if len(ddata) &gt; 1:
		username = ddata[1]
	if len(ddata) &gt; 2:
		process = ddata[2]

	print(&#34;PC name:&#34; &#43; computer)
	print(&#34;username:&#34; &#43; username)
	print(&#34;process name:&#34; &#43; process)

	raw_aes_hash256 = hashlib.sha256(raw_aes_keys)
	digest = raw_aes_hash256.digest()
	aes_key = digest[0:16]
	hmac_key = digest[16:]

	print(&#34;AES key:{}&#34;.format(aes_key.hex()))
	print(&#34;HMAC key:{}&#34;.format(hmac_key.hex()))



	print(hexdump.hexdump(ciphertext))

```
成功解密元数据，可以拿到`AES Key`和`HMAC Key`

![](/images/1710903213452.png)

```
Beacon id:1188523432
pid:4012
port:0
barch:x86
is64:1
bypass:False
windows var:54.46
windows build:12809
host:67.78.73.76
PC name:HUAN7155
username:Linchuan
process name:4321.exe
AES key:d62ad6c7a26831a42542089ea0347321
HMAC key:89635825b91c90e63d459b3de05ebfd2
00000000: 00 00 BE EF 00 00 00 4D  FD 16 72 C5 C7 28 ED 2A  .......M..r..(.*
00000010: 75 DE 6F 2D DE 7A 06 F0  A8 03 A8 03 46 D7 6D A8  u.o-.z......F.m.
00000020: 00 00 0F AC 00 00 04 36  2E 32 09 31 30 2E 32 31  .......6.2.10.21
00000030: 31 2E 35 35 2E 37 09 4C  49 4E 43 48 55 41 4E 37  1.55.7.LINCHUAN7
00000040: 31 35 35 09 4C 69 6E 63  68 75 61 6E 09 34 33 32  155.Linchuan.432
00000050: 31 2E 65 78 65                                    1.exe
```
然后再解密CS流量，既然存在通信，那么必然有数据传输，所以直接查看存在data字段的数据包。

![](/images/1710903261898.png)

因为cs的beacon模式返回包是定时任务去延期查询的，所以继续往下翻应该就能找到执行命令的结果。

![](/images/1710903270726.png)

再解密下hex数据。

![](/images/1710903297090.png)

解密出来的hex数据使用base64编码，再调用`CS_Task_AES_Decrypt.py`来解密执行的命令，记得替换解密脚本中的`shell_whoami`变量。
```python
&#39;&#39;&#39;
cobaltstrike任务解密
&#39;&#39;&#39;
import hmac
import binascii
import base64
import struct

import hexdump
from Crypto.Cipher import AES

def compare_mac(mac, mac_verif):
	if mac == mac_verif:
		return True
	if len(mac) != len(mac_verif):
		print
		&#34;invalid MAC size&#34;
		return False

	result = 0

	for x, y in zip(mac, mac_verif):
		result |= x ^ y

	return result == 0


def decrypt(encrypted_data, iv_bytes, signature, shared_key, hmac_key):
	if not compare_mac(hmac.new(hmac_key, encrypted_data, digestmod=&#34;sha256&#34;).digest()[0:16], signature):
		print(&#34;message authentication failed&#34;)
		return

	cypher = AES.new(shared_key, AES.MODE_CBC, iv_bytes)
	data = cypher.decrypt(encrypted_data)
	return data


def readInt(buf):
	return struct.unpack(&#39;&gt;L&#39;, buf[0:4])[0]

# 接收到的任务数据
shell_whoami= &#34;egbD/VKZd3OFBz/hQ0ue8bQgDJRZnCOxo2alKY&#43;W1HHDFHfMUrpfjdNKAMvG7WCt&#34;

if __name__ == &#34;__main__&#34;:
	# key源自Beacon_metadata_RSA_Decrypt.py
	SHARED_KEY = binascii.unhexlify(&#34;d62ad6c7a26831a42542089ea0347321&#34;)
	HMAC_KEY = binascii.unhexlify(&#34;89635825b91c90e63d459b3de05ebfd2&#34;)

	enc_data = base64.b64decode(shell_whoami)
	print(&#34;数据总长度:{}&#34;.format(len(enc_data)))
	signature = enc_data[-16:]
	encrypted_data = enc_data[:-16]

	iv_bytes = bytes(&#34;abcdefghijklmnop&#34;,&#39;utf-8&#39;)

	dec = decrypt(encrypted_data,iv_bytes,signature,SHARED_KEY,HMAC_KEY)

	counter = readInt(dec)
	print(&#34;时间戳:{}&#34;.format(counter))

	decrypted_length = readInt(dec[4:])
	print(&#34;任务数据包长度:{}&#34;.format(decrypted_length))

	data = dec[8:len(dec)]
	print(&#34;任务Data&#34;)
	print(hexdump.hexdump(data))

	# 任务标志
	Task_Sign=data[0:4]
	print(&#34;Task_Sign:{}&#34;.format(Task_Sign))

	# 实际的任务数据长度
	Task_file_len = int.from_bytes(data[4:8], byteorder=&#39;big&#39;, signed=False)
	print(&#34;Task_file:{}&#34;.format(Task_file_len))

	with open(&#39;data.bin&#39;, &#39;wb&#39;) as f:
		f.write(data[8:Task_file_len])

	print(hexdump.hexdump(data[Task_file_len:]))
```
解密之后可以看到执行的命令：

![](/images/1710903344847.png)

盲猜下一步要echo flag或者type flag.txt

![](/images/1710903437373.png)

果不其然，执行了`type C:\Users\Linchuan\5.txt`命令，那么下一步找这个的beacon返回包就行。

![](/images/1710903449598.png)

解密hex数据，进行base64编码。

![](/images/1710903460451.png)

然后再使用`Beacon_Task_return_AES_Decrypt.py`来解密
```python
# -*- coding: utf-8 -*-

&#39;&#39;&#39;
Beacon任务执行结果解密
&#39;&#39;&#39;
import hmac
import binascii
import base64
import struct
import hexdump
from Crypto.Cipher import AES

def compare_mac(mac, mac_verif):
	if mac == mac_verif:
		return True
	if len(mac) != len(mac_verif):
		print
		&#34;invalid MAC size&#34;
		return False

	result = 0

	for x, y in zip(mac, mac_verif):
		result |= x ^ y

	return result == 0

def decrypt(encrypted_data, iv_bytes, signature, shared_key, hmac_key):
	if not compare_mac(hmac.new(hmac_key, encrypted_data, digestmod=&#34;sha256&#34;).digest()[0:16], signature):
		print(&#34;message authentication failed&#34;)
		return

	cypher = AES.new(shared_key, AES.MODE_CBC, iv_bytes)
	data = cypher.decrypt(encrypted_data)
	return data

# key源自Beacon_metadata_RSA_Decrypt.py
SHARED_KEY = binascii.unhexlify(&#34;d62ad6c7a26831a42542089ea0347321&#34;)
HMAC_KEY = binascii.unhexlify(&#34;89635825b91c90e63d459b3de05ebfd2&#34;)

encrypt_data=&#34;AAAAwMw1gSQUNnEshHNdZb9fqnrD2hrBt1g76nnVTADFF4Zjl3hmI4GMsRr4FGC/lj59oL571Mivwn1Nfvt4POfTqInRTa2iqFHwspGa9CQu/cDkOtgAU7XX/8kzQW7Ahh0kKA9tgL9rrzkmTFNClrgWNfiyzpgk8Dg58apKKUEYa&#43;1AggKW5WN7ForWusCAHGx54sY/AxnpsSQ0hUwHIcw0oyPwRLYwsnlkePaAJZB3TRqD92n7Hiv7HFd7/gLZWPW0HA==&#34;

encrypt_data=base64.b64decode(encrypt_data)

encrypt_data_length=encrypt_data[0:4]

encrypt_data_length=int.from_bytes(encrypt_data_length, byteorder=&#39;big&#39;, signed=False)

encrypt_data_l = encrypt_data[4:len(encrypt_data)]

data1=encrypt_data_l[0:encrypt_data_length-16]
signature=encrypt_data_l[encrypt_data_length-16:encrypt_data_length]
iv_bytes = bytes(&#34;abcdefghijklmnop&#34;,&#39;utf-8&#39;)

dec=decrypt(data1,iv_bytes,signature,SHARED_KEY,HMAC_KEY)


counter = dec[0:4]
counter=int.from_bytes(counter, byteorder=&#39;big&#39;, signed=False)
print(&#34;counter:{}&#34;.format(counter))

dec_length = dec[4:8]
dec_length=int.from_bytes(dec_length, byteorder=&#39;big&#39;, signed=False)
print(&#34;任务返回长度:{}&#34;.format(dec_length))

de_data= dec[8:len(dec)]
Task_type=de_data[0:4]
Task_type=int.from_bytes(Task_type, byteorder=&#39;big&#39;, signed=False)
print(&#34;任务输出类型:{}&#34;.format(Task_type))

# print(de_data[4:dec_length].decode(&#39;utf-8&#39;))
print(de_data[4:dec_length])

print(hexdump.hexdump(dec))
```
最终可以看到命令执行返回的结果

![](/images/1710903485858.png)

---

> 作者: [1cePeak](https://1cepeak.cn)  
> URL: https://1cepeak.cn/posts/cobaltstrike-traffic-analysis/  

